﻿local ADDONNAME= ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")

local popupSize = 0
local CurrencyHUDCheckBox = nil
local currencyList = {}

function Currency_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");			--AddOn Loaded
	self:RegisterEvent("GLOBAL_MOUSE_UP");		--Mouse Button Up
	self:RegisterEvent("TRADE_CURRENCY_CHANGED");	
	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
end

function Currency_OnEvent(self, event, ...)
	--print(event)
	if (event == "ADDON_LOADED") then
 		if (...) == ADDONNAME then
			DEFAULT_CHAT_FRAME:AddMessage(ADDONNAME.." "..VERSION.." Loaded.");
			currencyList = CopyTable(MiniHUDCurrencySVPC)
			for k,v in pairs(currencyList) do 
				v.Frame = CreateFrame("Frame", k, CurrencyFrame,"EntryTemplate")
			end
			Currency_Update();
		end
	elseif event == "GLOBAL_MOUSE_UP" then
		if TokenFramePopup:IsShown() then
			-- First time opening the popup frame
			if popupSize == 0 then 
				popupSize = TokenFramePopup:GetHeight() + 22
				CurrencyHUDCheckBox = CreateFrame("CheckButton", "CurrencyHUDCheckBox", TokenFramePopup, "OptionsSmallCheckButtonTemplate" )
				CurrencyHUDCheckBox:SetPoint("TOPLEFT" , TokenFramePopupBackpackCheckBox, "BOTTOMLEFT", 0, 4)
				CurrencyHUDCheckBox:SetSize(26,26)
				_G[CurrencyHUDCheckBox:GetName().."Text"]:SetText("|cffffffffTrack with |cff20B020MiniHUD|r");
				CurrencyHUDCheckBox:SetScript("OnClick", Currency_CheckBox)
				CurrencyHUDCheckBox:Show()
				TokenFramePopup:SetHeight(popupSize)
			end
			-- Get which token is selected
			-- Update the checkbox with the checked value of the currently selected currency.
			if currencyList[TokenFrame.selectedToken] ~= nil then
				CurrencyHUDCheckBox:SetChecked(currencyList[TokenFrame.selectedToken].Checked)
			else
				CurrencyHUDCheckBox:SetChecked(false)
			end
		end
	elseif event == "CURRENCY_DISPLAY_UPDATE" then
		Currency_Update()
	end
end

function Currency_CheckBox()
	local name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered, rarity = GetCurrencyInfo(GetCurrencyListLink(TokenFrame.selectedID))
	if currencyList[name] ~= nil then
		currencyList[name].Checked = CurrencyHUDCheckBox:GetChecked()
	else
		newframe = CreateFrame("Frame", name, CurrencyFrame,"EntryTemplate")
		currencyList[name] = {Link = GetCurrencyListLink(TokenFrame.selectedID), Checked = true, Texture = texture, Amount = currentAmount, Max = totalMax, Frame = newframe}
	end
	Currency_Update()
end

function Currency_Update()
	local list = ""
	local count = 1
	local lastFrame = nil
	for k,v in pairs(currencyList) do 
		local name, currentAmount, _, _, _, totalMax = GetCurrencyInfo(v.Link)
		currencyList[name].Amount = currentAmount
		currencyList[name].Max = totalMax
		if v.Checked then
			count = count + 1
			currencyList[name].Frame:Show()
			currencyList[name].Frame.Text:SetText(name)
			currencyList[name].Frame.Value:SetText(currencyList[name].Amount..(currencyList[name].Max ~= 0 and ("/"..currencyList[name].Max) or ""))
			currencyList[name].Frame.Icon:SetTexture(currencyList[name].Texture)
			if lastFrame == nil then
				currencyList[name].Frame:SetPoint("TOPLEFT", CurrencyFrame, "TOPLEFT", 4,-4)
				else
				currencyList[name].Frame:SetPoint("TOPLEFT", lastFrame, "BOTTOMLEFT", 0,-2)
			end
			lastFrame = currencyList[name].Frame
		else 
			currencyList[name].Frame:Hide()
		end
	end
	if count == 1 then 
		Currency:Hide()
	else
		Currency:Show()
	end
	Currency:SetWidth(242);
	Currency:SetHeight((count-1) * 18 + 8);
	MiniHUDCurrencySVPC = CopyTable(currencyList)
end
--name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered, rarity = GetCurrencyInfo(id or "currencyLink" or "currencyString")